package dk.nsp.idsas.service;

import dk.nsp.idsas.dao.BlurringDao;
import dk.nsp.idsas.dao.WhitelistDao;
import dk.nsp.idsas.dto.OrganizationIdDto;
import dk.nsp.idsas.integrations.sores.SoresClient;
import dk.nsp.idsas.util.*;
import org.apache.log4j.Logger;

import java.util.ArrayList;
import java.util.List;

public class OrgBlurringService {
    private static final Logger logger = Logger.getLogger(OrgBlurringService.class);

    private final WhitelistDao whitelistDao;
    private final BlurringDao blurringDao;
    private final AuditLogger auditLogger;
    private final SoresClient soresClient;

    public OrgBlurringService(WhitelistDao whitelistDao, BlurringDao blurringDao, AuditLogger auditLogger, SoresClient soresClient) {
        this.whitelistDao = whitelistDao;
        this.blurringDao = blurringDao;
        this.auditLogger = auditLogger;
        this.soresClient = soresClient;
    }

    /**
     * Opretter en ny afdelingssløring.
     * <ul>
     * <li>Der gemmes {id, orgID, orgClassification, CVR (fra SOSI ID-kortet), validFrom, validTo}</li>
     * <li>Understøttede organisationer i createOrgBlurring skal i første omgang begrænses til SOR og SHAK. Hvis der registreres en SOR-kode, skal det valideres at SOR-koden eksisterer via kald til SORES. Findes den ikke, skal funktionen fejle. SHAK koder kontrolleres ikke.</li>
     * <li>Funktionen skal fejle ved genregistrering af en aktiv afdelingssløring.</li>
     * <li>Sikkerheden skal være DGWS niveau 3 (System ID-kort)</li>
     * <li>ValidFrom sættes til 'nu'</li>
     * </ul>
     * @param createOrgBlurring a new {@code CreateOrgBlurring}
     * @return OK hvis alt går godt
     */
    public void createOrgBlurring(String organizationId, String organizationIdType) throws IdsasServiceException {

    }

    /**
     * Returnerer listen af registrerede afdelinger hørende til CVR nummeret i SOSI ID-kortet.<br/>
     * Sikkerheden skal være DGWS niveau 3 (System ID-kort)
     */
    public List<OrganizationIdDto> listOrgBlurringsForCVR(String organizationId, String organizationIdType) {
        // TODO: Implement
        return new ArrayList<>();
    }

    /**
     * Returnerer listen af registrerede afdelinger hørende til CVR nummeret i SOSI ID-kortet.<br/>
     * Sikkerheden skal være DGWS niveau 3 (System ID-kort)
     */
    public List<OrganizationIdDto> listAllActiveOrgBlurrings() {
        // TODO: Implement
        return new ArrayList<>();
    }

    /**
     * Inaktiverer en afdelingssløring per 'nu' (sætter validTo til 'nu'). Der skal kontrolleres at en aktive sløring har samme CVR nummer som CVR-nummeret i det medsendte SOSI ID-kort.
     * <ul>
     * <li>ValidTo for sløringen sættes til “nu”.</li>
     * <li>Skal fejle, hvis man forsøger at fjerne en ikke eksisterende afdelingssløring eller hvis man forsøger at fjerne en afdelingssløring, der ikke hører til kalderens CVR-nummer (fra SOSI ID-kortet).</li>
     * </ul>
     * Sikkerheden skal være DGWS niveau 3 (System ID-kort)
     */
    public String removeOrgBlurring(String organizationId, String organizationIdType) {
        // TODO: Implement
        return "OK";
    }

}
